%define anolis_release 2

%bcond_with check
%global srcname joblib

Name:  python-%{srcname}
Version: 1.2.0
Release: %{anolis_release}%{dist}

Summary: Lightweight pipelining: using Python functions as pipeline jobs

License: BSD
URL: https://joblib.readthedocs.io
Source0: %{pypi_source}

Patch: 0001-joblib-unbundle-cloudpickle.patch

BuildArch:      noarch
BuildRequires:  python3-devel
# setup.py imports joblib and that needs cloudpickle
BuildRequires:  %{py3_dist cloudpickle}

%global _description %{expand:
Joblib is a set of tools to provide lightweight pipelining in Python.
In particular, joblib offers:
 * transparent disk-caching of the output values and lazy
   re-evaluation (memorize pattern)
 * easy simple parallel computing
 * logging and tracing of the execution}

%description %_description

%package -n python3-%{srcname}
Summary: %{summary}

# Testing
%if %{with check}
BuildRequires:  %{py3_dist pytest}
BuildRequires:  %{py3_dist numpy}
BuildRequires:  %{py3_dist lz4}
BuildRequires:  %{py3_dist psutil} 
BuildRequires:  %{py3_dist threadpoolctl}
%endif

Recommends: %{py3_dist numpy}
Recommends: %{py3_dist lz4}
Recommends: %{py3_dist psutil} 
Provides: bundled(python3dist(loky)) = 2.9.0

%description -n python3-%{srcname}
%_description

%package -n python3-%{srcname}-doc
Summary:        Documentation files for %{name}
Requires:       python3-%{srcname} = %{EVR}
BuildArch:      noarch

%description -n python3-%{srcname}-doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n %{srcname}-%{version}
rm joblib/externals/cloudpickle/ -rf

%generate_buildrequires
%pyproject_buildrequires

%build
%pyproject_wheel

%install
%pyproject_install

%pyproject_save_files joblib

%if %{with check}
%check
%pytest \
 --deselect "joblib/test/test_memory.py::test_parallel_call_cached_function_defined_in_jupyter" \
 --deselect "joblib/test/test_numpy_pickle.py::test_compress_mmap_mode_warning" \
  joblib

%endif

%files -n python3-%{srcname} -f %{pyproject_files}

%files -n python3-%{srcname}-doc
%doc README.rst

%changelog
* Fri Mar 22 2024 Zhao Hang <wb-zh951434@alibaba-inc.com> - 1.2.0-2
- Rebuild with python3.11

* Tue Mar 28 2023 yuanhui <yuanhui@linux.alibaba.com> - 1.2.0-1
- Init package from upstream
